unit mtrandom;

{***************************************************************************

  Mersenne Twister 
   - mt19937ar.c, mt19937ar-cok.c̈ڐA

  rev  0
  date 2004/05/02
  auth fT
  memo o

  rev  1
  date 2008/11/01
  auth fT
  memo TRnd̔hNXɉ

 ***************************************************************************}

interface

uses
  windows,basernd;

const
  MT_N = 624;

type
  TMTRnd = class(TRnd)
  private
    Idx : integer;
    State : array[0..MT_N-1] of DWORD;
  protected
    procedure   NextState;
  public
    procedure   SetSeed(ASeed:DWORD); override;
    procedure   SetSeed(ASeeds:array of DWORD); override;
    function    Rand:DWORD; override;
  end;

implementation

const
  MT_M     = 397;

procedure   TMTRnd.SetSeed(ASeed:DWORD);
var
  j : DWORD;
begin
  state[0]:=ASeed;
  FOR j:=1 TO MT_N-1 DO BEGIN
    state[j] := (1812433253 * (state[j-1] XOR (state[j-1] SHR 30)) + j);
    //state[j] &= 0xffffffffUL;  /* for >32 bit machines */
  END;
  Idx:=MT_N-1;
end;

procedure   TMTRnd.SetSeed(ASeeds:array of DWORD);
var
  i,j,k,keylen:DWORD;
begin
  SetSeed(19650218);
  i:=1; j:=0;
  keylen:=High(ASeeds)+1;
  IF keylen<MT_N THEN k:=MT_N ELSE k:=keylen;
  WHILE k>0 DO BEGIN
    state[i]:=(state[i] XOR ((state[i-1] XOR (state[i-1] SHR 30) ) * 1664525)) + ASeeds[j]+j; // non linear
    Inc(i); Inc(j);
    IF i>=MT_N THEN BEGIN
      state[0]:=state[MT_N-1]; i:=1;
    END;
    IF j>=keylen THEN j:=0;
    Dec(k);
  END;
  k:=MT_N-1;
  WHILE k>0 DO BEGIN
    state[i]:=(state[i] XOR ((state[i-1] XOR (state[i-1] SHR 30)) * 1566083941)) - i; //* non linear */
    Inc(i);
    IF i>=MT_N THEN BEGIN
      state[0] := state[MT_N-1]; i:=1;
    END;
    Dec(k);
  END;
  state[0]:=$80000000;
  idx:=MT_N-1;
end;

procedure   TMTRnd.NextState;
const
  U_MASK   = $80000000;
  L_MASK   = $7FFFFFFF;
  MATRIX_A = $9908b0df;
  mat : array[0..1] of DWORD = ($0, MATRIX_A);
var
  j : integer;
  y : DWORD;
begin
  idx:=0;
  FOR j:=0 TO MT_N-MT_M-1 DO BEGIN
    y:=(state[j] AND U_MASK) OR (state[j+1] AND L_MASK);
    state[j]:=state[j+MT_M] XOR (y SHR 1) XOR mat[y AND 1];
  END;
  FOR j:=MT_N-MT_M TO MT_N-2 DO BEGIN
    y:=(state[j] AND U_MASK) OR (state[j+1] AND L_MASK);
    state[j]:=state[j+MT_M-MT_N] XOR (y SHR 1) XOR mat[y AND 1];
  END;
  y:=(state[MT_N-1] AND U_MASK) OR (state[0] AND L_MASK);
  state[MT_N-1]:=state[MT_M-1] XOR (y SHR 1) XOR mat[y AND 1];
end;

function    TMTRnd.Rand:DWORD;
begin
  Inc(Idx);
  IF Idx>=MT_N THEN NextState;
  result:=state[idx];
  result:=result XOR (result SHR 11);
  result:=result XOR ((result SHL 7) AND $9d2c5680);
  result:=result XOR ((result SHL 15) AND $efc60000);
  result:=result XOR (result SHR 18);
end;


end.
