unit resultdatas;

interface

uses
  sysutils,math;

const
  MaxCount = 100;

type
  TResultDatas = class(TObject)
  protected
    FDatas : array[0..MaxCount-1] of Cardinal;
    FIdx : cardinal;
  public
    constructor Create;
    procedure   Clear;
    procedure   AddData(ATime:Cardinal);
    function    IsDone:boolean;
    function    GetResult:string;
  end;

implementation

constructor TResultDatas.Create;
begin
  inherited Create;
  Clear;
end;

procedure   TResultDatas.Clear;
begin
  FIdx:=0;
  FillChar(FDatas[0],sizeof(FDatas),0);
end;

procedure   TResultDatas.AddData(ATime:Cardinal);
begin
  if IsDone then exit;
  FDatas[FIdx]:=ATime;
  Inc(FIdx);
end;

function    TResultDatas.IsDone:boolean;
begin
  result:=(FIdx>=MaxCount);
end;

function    TResultDatas.GetResult:string;
var
  i: integer;
  t,t1,mx,mn : cardinal;
  s0,s1 : single;
  tt : array[0..MaxCount-1] of single;
begin
  result:='n/a';
  if FIdx=0 then exit;
  //
  t:=0; mx:=0; mn:=$FFFFFFFF;
  for i:=0 to FIdx-1 do begin
    Inc(t,FDatas[i]);
    if mx<FDatas[i] then mx:=FDatas[i];
    if mn>FDatas[i] then mn:=FDatas[i];
    tt[i]:=FDatas[i];
  end;
  // W΍߂
  s0:=t / FIdx; s1:=0.0;
  for i:=0 to FIdx-1 do
    s1:=s1+Sqr(tt[i]-s0);
  s1:=sqrt(s1/FIdx);
  //
  t1:=t div FIdx;
  t:=(t-t1*FIdx)*10 div FIdx;
  result:='N='+IntToStr(FIdx)+', ave='+IntToStr(t1)+'.'+IntToStr(t)+'msec'#13#10+
          'Min='+IntToStr(mn)+'msec, Max='+IntToStr(mx)+'msec'#13#10+
          '='+FloatToStr(s1);
end;

end.
