unit rndthrd;

interface

uses
  classes,sysutils,windows,mmsystem,basernd,sysrnd,mrandom,mtrandom,sfmtrandom,xsrandom;

type
  TRandomThread = class(TThread)
  private
    FRnd : TRnd;
    FLapTime : DWORD;
    FWnd : THandle;
    FMsg : DWORD;
  protected
    procedure Execute; override;
  public
    constructor Create(ARndClass : TRandomBase; AWnd:THandle; AMsgNo:DWORD);
    destructor  Destroy; override;
    property    LapTime:DWORD read FLapTime;
  end;

implementation

constructor TRandomThread.Create(ARndClass : TRandomBase; AWnd:THandle; AMsgNo:DWORD);
begin
  FRnd:=ARndClass.Create;
  FLapTime:=0;
  FreeOnTerminate:=true;
  FWnd:=AWnd;
  FMsg:=AMsgNo;
  inherited Create;
end;

destructor  TRandomThread.Destroy;
begin
  if assigned(FRnd) then FRnd.Free;
  inherited Destroy;
end;

procedure TRandomThread.Execute;
var
  i,s : DWORD;
  r : MMResult;
begin
  r:=timeBeginPeriod(1);
  if r=TIMERR_NOERROR then
    s:=timeGetTime
  else
    s:=GetTickCount;
  try
{$O-}
    For i:=1 TO 10000000 DO
      FRnd.Rand;
{$O+}
    if r=TIMERR_NOERROR then
      FLapTime:=timeGetTime-s
    else
      FLapTime:=GetTickCount-s;
    PostMessage(FWnd,FMsg,FLapTime,0);
  finally
    if r=TIMERR_NOERROR then timeEndPeriod(1);
  end;
end;

end.
