unit testf;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,
  rndthrd, resultdatas, basernd;

const
  WM_ENDMSG = WM_APP + 1;

type
  TForm1 = class(TForm)
    StartBtn: TButton;
    StopBtn: TButton;
    Label1: TLabel;
    ResultLB: TLabel;
    RndRG: TRadioGroup;
    Button1: TButton;
    procedure StopBtnClick(Sender: TObject);
    procedure StartBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private 錾 }
    t : TRandomThread;
    br : TRandomBase;
    fstop : boolean;
    datas : TResultDatas;
    procedure WmEndMsg(var AMsg:TMessage); message WM_ENDMSG;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses
  sysrnd,mrandom,mtrandom,sfmtrandom,xsrandom,sfmtsse2random;

procedure TForm1.Button1Click(Sender: TObject);
const
  Seed = $10203040;
var
  i,j : integer;
  a,b : DWORD;
  s1 : TSFMTRnd;
  s2 : TSFMTSSE2Rnd;
begin
  s1:=TSFMTRnd.Create(Seed);
  try
    s2:=TSFMTSSE2Rnd.Create(Seed);
    try
      j:=-1;
      for i:=0 TO 10000000 do begin
        a:=s1.rand; b:=s2.Rand;
        if a<>b then begin
          j:=i;
          break;
        end;
      end;
      if j=-1 then
        ShowMessage('ok!')
      else
        ShowMessage('index='+IntToStr(j)+' : s1='+IntToStr(a)+' <> s2='+IntToStr(b));
    finally
      s2.free;
    end;
  finally
    s1.free;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  t:=nil;
  fstop:=false;
  datas:=TResultDatas.Create;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  if t<>nil then
    t.free;
  if datas<>nil then
    datas.free;
end;

procedure TForm1.StartBtnClick(Sender: TObject);
begin
  br:=TSysRnd;
  case RndRG.ItemIndex of
    0: br:=TSysRnd;
    1: br:=TMRnd;
    2: br:=TMTRnd;
    3: br:=TSFMTRnd;
    4: br:=TSFMTSSE2Rnd;
    5: br:=TXorShiftRnd;
  end;
  fstop:=false;
  StartBtn.Enabled:=false;
  StopBtn.Enabled:=true;
  ResultLB.Caption:='v';
  t:=TRandomThread.Create(br,handle,WM_ENDMSG);
end;

procedure TForm1.StopBtnClick(Sender: TObject);
begin
  if t<>nil then begin
    t.Terminate;
    fstop:=true;
  end;
end;

procedure TForm1.WmEndMsg(var AMsg:TMessage);
begin
  if fstop then
    ResultLB.Caption:='v~'
  else begin
    datas.AddData(AMsg.WParam);
    if not datas.IsDone then begin
      t:=TRandomThread.Create(br,handle,WM_ENDMSG);
      exit;
    end;
    ResultLB.Caption:=datas.GetResult;
  end;
  datas.Clear;
  StartBtn.Enabled:=true;
  StopBtn.Enabled:=false;
  t:=nil;
end;

end.
