﻿unit xsrandom;

{***************************************************************************

  XorShift 乱数生成器
   - http://www.jstatsoft.org/v08/i14/

  date 2008/11/02
  auth 綾川鞠乃介
  memo 初出

 ***************************************************************************}

interface

uses
  windows,basernd;

type
  TXorShiftRnd = class(TRnd)
  private
    x,y,z,w : DWORD;
  protected
    //procedure   AutoSeed; override;
  public
    function    Rand:DWORD;override;
    procedure   SetSeed(ASeed:DWORD); override;
    procedure   SetSeed(ASeeds:array of DWORD); override;
  end;

implementation

function    TXorShiftRnd.Rand:DWORD;
var
  t : DWORD;
begin
  t:=x XOR ( x SHL 11 ); x:=y; y:=z; z:=w;
  w:= (w XOR (w SHR 19)) XOR (t XOR (t SHR 8));
  result:=w;
end;

{
procedure   TXorShiftRnd.AutoSeed;
begin
  x:=123456789;
  y:=362436069;
  z:=521288629;
  w:=88675123;
end;
}

procedure   TXorShiftRnd.SetSeed(ASeed:DWORD);
var
  s : DWORD;
begin
  s:=ASeed;
  s:=1812433253*( s XOR ( s SHR 30 ) )+1;
  x:=s;
  s:=1812433253*( s XOR ( s SHR 30 ) )+2;
  y:=s;
  s:=1812433253*( s XOR ( s SHR 30 ) )+3;
  z:=s;
  w:=1812433253*( s XOR ( s SHR 30 ) )+4;
end;

procedure   TXorShiftRnd.SetSeed(ASeeds:array of DWORD);
var
  lim : integer;
begin
  AutoSeed;
  lim:=High(ASeeds);
  if lim<1 then exit;
  case lim of
    1 : begin
          w:=ASeeds[0];
        end;
    2 : begin
          w:=ASeeds[0]; z:=ASeeds[1];
        end;
    3 : begin
          w:=ASeeds[0]; z:=ASeeds[1]; y:=ASeeds[2];
        end;
    ELSE BEGIN
      w:=ASeeds[0]; z:=ASeeds[1]; y:=ASeeds[2]; x:=ASeeds[3];
    END;
  end;
end;

end.
